## adios 1.13.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.0)

#move here bedore project, otherwise SET(CMAKE_INSTALL_PREFIX < install_path>) will not work
if(NOT CMAKE_INSTALL_PREFIX)
  # if CMAKE_INSTALL_PREFIX isn't set, try to get it from the INSTALL_PREFIX environment variable
  set(CMAKE_INSTALL_PREFIX $ENV{INSTALL_PREFIX} CACHE PATH "Prefix prepended to install directories" FORCE)
endif()

project(ADIOS_PROJECT)

SET_PROPERTY(GLOBAL PROPERTY ALLOW_DUPLICATE_CUSTOM_TARGETS 1)

#set(LANGUAGE "" CACHE FILEPATH "")  #C/CXX/Fortran

#enable_language(${LANGUAGE})
#message(STATUS "CMAKE_${LANGUAGE}_COMPILER_WORKS = ${CMAKE_${LANGUAGE}_COMPILER_WORKS}")

include_directories(${PROJECT_SOURCE_DIR})
link_directories(${PROJECT_BINARY_DIR})
#message("${PROJECT_SOURCE_DIR}")

#set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR})

#if(NOT CMAKE_INSTALL_PREFIX)
#  set(CMAKE_INSTALL_PREFIX $ENV{INSTALL_PREFIX} CACHE PATH "Prefix prepended to install directories" FORCE)
#endif()

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix ${prefix})
set(bindir ${exec_prefix}/bin)
#set(datadir ${prefix}/share)
set(libdir ${exec_prefix}/lib)
set(includedir ${prefix}/include)
set(sysconfdir ${prefix}/etc)

#set(Python_ADDITIONAL_VERSIONS 2.7 2.6 2.5 2.4 2.3 2.2 2.1 2.0)
find_package(PythonInterp)
#message(STATUS "PYTHON_EXECUTABLE = ${PYTHON_EXECUTABLE}")
#message(STATUS "PYTHONINTERP_FOUND = ${PYTHONINTERP_FOUND}")
#message(STATUS "PYTHON_VERSION_STRING = ${PYTHON_VERSION_STRING}")
#message(STATUS "PYTHON_VERSION_MAJOR = ${PYTHON_VERSION_MAJOR}")
if (NOT PYTHONINTERP_FOUND OR NOT ${PYTHON_VERSION_MAJOR} GREATER 1)
    message(FATAL_ERROR "Python 2.x or 3.x is required to build ADIOS.")
else()
    message(STATUS "Python ${PYTHON_VERSION_STRING} will be used in building ADIOS")
endif()



if(DEFINED ENV{MACRODEFFLAG})
  set(MACRODEFFLAG $ENV{MACRODEFFLAG})
else()
  set(MACRODEFFLAG "-D")
endif()
message(STATUS "MACRODEFFLAG = ${MACRODEFFLAG}")

set(LIBS "")
set(CPPFLAGS "$ENV{CPPFLAGS}")
set(CFLAGS "$ENV{CFLAGS}")
if(DEFINED ENV{EXTRA_CFLAGS})
    set(EXTRA_CFLAGS "$ENV{EXTRA_CFLAGS}")
endif()
if(DEFINED ENV{EXTRA_LIBS})
    set(EXTRA_LIBS "$ENV{EXTRA_LIBS}")
endif()
######## file moved from initial_cache.cmake to indicate external library is used(ON) or not (OFF)######
if(DEFINED ENV{BUILD_WRITE})
  if("$ENV{BUILD_WRITE}" STREQUAL "")
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE $ENV{BUILD_WRITE})
  endif()
  if(BUILD_WRITE)
    set(BUILD_WRITE ON CACHE BOOL "")
  else()
    set(BUILD_WRITE OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_WRITE ON CACHE BOOL "")
endif()

if(DEFINED ENV{BUILD_FORTRAN})
  if("$ENV{BUILD_FORTRAN}" STREQUAL "")
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN $ENV{BUILD_FORTRAN})
  endif()
  if(BUILD_FORTRAN)
    set(BUILD_FORTRAN ON CACHE BOOL "")
  else()
    set(BUILD_FORTRAN OFF CACHE BOOL "")
  endif()
else()
  set(BUILD_FORTRAN ON CACHE BOOL "")
endif()

if(DEFINED ENV{adios_timers})
  if("$ENV{adios_timers}" STREQUAL "")
    set(ADIOS_TIMERS 0)
  elseif("$ENV{adios_timers}" STREQUAL "ON")
    set(ADIOS_TIMERS 1)
  elseif("$ENV{adios_timers}" STREQUAL "on")
    set(ADIOS_TIMERS 1)
  elseif("$ENV{adios_timers}" STREQUAL "OFF")
    set(ADIOS_TIMERS 0)
  elseif("$ENV{adios_timers}" STREQUAL "off")
    set(ADIOS_TIMERS 0)
  else()
    set(ADIOS_TIMERS 0)
  endif()
  if(ADIOS_TIMERS)
    set(SKEL_HAVE_ADIOS_TIMING True)
  else()
    set(SKEL_HAVE_ADIOS_TIMING False)
  endif()
else()
  # default is on if not specified
  set(ADIOS_TIMERS 1)
  set(SKEL_HAVE_ADIOS_TIMING True)
endif()

if(DEFINED ENV{adios_timer_events})
  if("$ENV{adios_timer_events}" STREQUAL "")
    set(ADIOS_TIMER_EVENTS 0)
  elseif("$ENV{adios_timer_events}" STREQUAL "ON")
    set(ADIOS_TIMER_EVENTS 1)
  elseif("$ENV{adios_timer_events}" STREQUAL "on")
    set(ADIOS_TIMER_EVENTS 1)
  elseif("$ENV{adios_timer_events}" STREQUAL "OFF")
    set(ADIOS_TIMER_EVENTS 0)
  elseif("$ENV{adios_timer_events}" STREQUAL "off")
    set(ADIOS_TIMER_EVENTS 0)
  else()
    set(ADIOS_TIMER_EVENTS 0)
  endif()
else()
  #default is off if not specified
  set(ADIOS_TIMER_EVENTS 0)
endif()

if(DEFINED ENV{bgq})
  if("$ENV{bgq}" STREQUAL "")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "ON")
    set(HAVE_BGQ 1)
    set(BGQ ON CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "on")
    set(HAVE_BGQ 1)
    set(BGQ ON CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "OFF")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  elseif("$ENV{bgq}" STREQUAL "Off")
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  else()
    set(HAVE_BGQ 0)
    set(BGQ OFF CACHE BOOL "")
  endif()
else()
  set(HAVE_BGQ 0)
  set(BGQ OFF CACHE BOOL "")
endif()

if(DEFINED ENV{research_transports})
  if("$ENV{research_transports}" STREQUAL "")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "OFF")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "off")
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  elseif("$ENV{research_transports}" STREQUAL "on")
    set(RESEARCH_TRANSPORTS 1)
    message("research_transports is enabled")
  elseif("$ENV{research_transports}" STREQUAL "ON")
    set(RESEARCH_TRANSPORTS 1)
    message("research_transports is enabled")
  else()
    set(RESEARCH_TRANSPORTS 0)
    message("research_transports is NOT enabled")
  endif()
else()
  set(RESEARCH_TRANSPORTS 0)
  message("research_transports is NOT enabled")
endif()

set(MXML_DIR $ENV{MXML_DIR}  CACHE FILEPATH "path to mxml dir")

set(DATATAP OFF CACHE BOOL "")

set(NSSI OFF CACHE BOOL "")

if(DEFINED ENV{SEQ_NC_DIR})
  if("$ENV{SEQ_NC_DIR}" STREQUAL "")
    set(NETCDF OFF CACHE BOOL "")
  else()
    set(NETCDF ON CACHE BOOL "")
    set(NETCDF_DIR "$ENV{SEQ_NC_DIR}" CACHE FILEPATH "path to suquential NETCDF dir")
  endif()
else()
  set(NETCDF OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PAR_NC_DIR})
  if("$ENV{PAR_NC_DIR}" STREQUAL "")
    set(NC4PAR OFF CACHE BOOL "")
  else()
    set(NC4PAR ON CACHE BOOL "")
    set(NC4PAR_DIR "$ENV{PAR_NC_DIR}" CACHE FILEPATH "path to parallel NETCDFdir")
  endif()
else()
  set(NC4PAR OFF CACHE BOOL "")
endif()

#if(DEFINED ENV{PAR_NC_DIR} AND DEFINED ENV{PAR_NC_CLIB})
#  set(NC4PAR ON CACHE BOOL "")
#  set(NC4PAR_DIR $ENV{PAR_NC_DIR} CACHE FILEPATH "")
#  set(NC4PAR_CPPFLAGS "-I${NC4PAR_DIR}/include")
#  set(NC4PAR_LIBS $ENV{PAR_NC_CLIB} CACHE STRING "parallel netcdf")
#else()
#  set(NC4PAR OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{SEQ_NC_DIR} AND DEFINED ENV{SEQ_NC_CLIB})
#  set(NETCDF ON CACHE BOOL "")
#  set(NETCDF_DIR $ENV{SEQ_NC_DIR} CACHE FILEPATH "")
#  set(NETCDF_CPPFLAGS "-I${NETCDF_DIR}/include")
#  set(NETCDF_LIBS $ENV{SEQ_NC_CLIB} CACHE STRING "")
#else()
#  set(NETCDF OFF CACHE BOOL "")
#endif()

#if(DEFINED ENV{PAR_HDF5_DIR} AND DEFINED ENV{PAR_HDF5_CLIB})
#  set(PHDF5 ON CACHE BOOL "")
#  set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
#  set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#  set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
#else()
#  set(PHDF5 OFF CACHE BOOL "")
#endif()

if(DEFINED ENV{PAR_HDF5_DIR})
  if("$ENV{PAR_HDF5_DIR}" STREQUAL "")
    set(PHDF5 OFF CACHE BOOL "")
  else()
    set(PHDF5 ON CACHE BOOL "")
    set(PHDF5_DIR $ENV{PAR_HDF5_DIR} CACHE FILEPATH "path to parallel hdf5 dir")
    set(PHDF5_FLAGS "-I${PHDF5_DIR}/include")
#   set(PHDF5_LIBS $ENV{PAR_HDF5_CLIB} CACHE STRING "parallel hdf5")
  endif()
else()
  set(PHDF5 OFF CACHE BOOL "")
endif()

if(DEFINED ENV{PORTALS_DIR})
  if("$ENV{PORTALS_DIR}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS_DIR}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
elseif(DEFINED ENV{PORTALS})
  if("$ENV{PORTALS}" STREQUAL "")
    set(PORTALS OFF CACHE BOOL "")
  else()
    set(PORTALS_DIR "$ENV{PROTALS}" CACHE STRING "path to protals")
    set(PORTALS ON CACHE BOOL "")
  endif()
else()
  set(PORTALS OFF CACHE BOOL "")
endif()

if(DEFINED ENV{DATASPACES_INCDIR})
  if("${DATASPACES_INCDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "")
  else()
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "")
endif()
if(DEFINED ENV{DATASPACES_LIBDIR})
  if("${DATASPACES_LIBDIR}" STREQUAL "")
    set(DATASPACES OFF CACHE BOOL "" FORCE)
  else()
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE INTERNAL "Internal variable")
  endif()
else()
  set(DATASPACES OFF CACHE BOOL "" FORCE)
endif()
if(DEFINED DATASPACES_INCDIR)
  if(DEFINED DATASPACES_LIBDIR)
    set(DATASPACES ON CACHE BOOL "" FORCE)
    set(DATASPACES_INCDIR "$ENV{DATASPACES_INCDIR}" CACHE STRING "" FORCE)
    set(DATASPACES_LIBDIR $ENV{DATASPACES_LIBDIR} CACHE STRING "" FORCE)
  endif()
endif()
if("${DATASPACES}" STREQUAL "OFF")
  if(DEFINED ENV{DATASPACES_DIR})
    if(NOT "$ENV{DATASPACES_DIR}" STREQUAL "")
      set(DATASPACES ON CACHE BOOL "" FORCE)
      set(DATASPACES_DIR $ENV{DATASPACES_DIR} CACHE FILEPATH "path to dataspaces dir")
    endif()
#  set(DATASPACES_LIBS "-L$ENV{DATASPACES_DIR}/libs -ldspaces -ldscommon
#  -ldar" CACHE STRING "dataspace libs")
  else()
    if(NOT "$ENV{DATASPACES}" STREQUAL "")
      set(DATASPACES_DIR $ENV{DATASPACES} CACHE FILEPATH "path to dataspaces dir")
      set(DATASPACES ON CACHE BOOL "" FORCE)
    endif()
  endif()
endif()

if(DEFINED ENV{CRAY_PMI_DIR})
  set(CRAY_PMI_DIR $ENV{CRAY_PMI_DIR})
  if(CRAY_PMI_DIR)
    set(CRAY_PMI ON CACHE BOOL "")
    set(CRAY_PMI_LIBS_PATH "${CRAY_PMI_DIR}/lib64" CACHE STRING "")
    set(CRAY_PMI_CPPFLAGS "-I${CRAY_PMI_DIR}/include" CACHE STRING "")
  else()
    set(CRAY_PMI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_PMI OFF CACHE BOOL "")
endif()

if(DEFINED ENV{CRAY_UGNI_DIR})
  set(CRAY_UGNI_DIR $ENV{CRAY_UGNI_DIR})
  if(CRAY_UGNI_DIR)
    set(CRAY_UGNI ON CACHE BOOL "")
    set(CRAY_UGNI_LIBS_PATH "${CRAY_UGNI_DIR}/lib64" CACHE STRING "")
    set(CRAY_UGNI_CPPFLAGS "-I${CRAY_UGNI_DIR}/include")
  else()
    set(CRAY_UGNI OFF CACHE BOOL "")
  endif()
else()
  set(CRAY_UGNI OFF CACHE BOOL "")
endif()

if(DATASPACES)
  set(DIMES ON CACHE BOOL "")
else()
  set(DIMES OFF CACHE BOOL "")
endif()

if(DEFINED ENV{FLEXPATH_INCDIR})
  if("${FLEXPATH_INCDIR}" STREQUAL "")
    set(FLEXPATH OFF CACHE BOOL "")
  else()
    set(FLEXPATH_INCDIR "$ENV{FLEXPATH_INCDIR}" CACHE INTERNAL "Internal variable")
  endif()
else()
  set(FLEXPATH OFF CACHE BOOL "")
endif()
if(DEFINED ENV{FLEXPATH_LIBDIR})
  if("${FLEXPATH_LIBDIR}" STREQUAL "" FORCE)
    set(FLEXPATH OFF CACHE BOOL "")
  else()
    set(FLEXPATH_LIBDIR $ENV{FLEXPATH_LIBDIR} CACHE INTERNAL "Internal variable")
  endif()
else()
  set(FLEXPATH OFF CACHE BOOL "" FORCE)
endif()
if(DEFINED FLEXPATH_INCDIR)
  if(DEFINED FLEXPATH_LIBDIR)
    set(FLEXPATH ON CACHE BOOL "" FORCE)
    set(FLEXPATH_INCDIR "$ENV{FLEXPATH_INCDIR}" CACHE STRING "" FORCE)
    set(FLEXPATH_LIBDIR $ENV{FLEXPATH_LIBDIR} CACHE STRING "" FORCE)
  endif()
endif()
if("${FLEXPATH}" STREQUAL "OFF")
  if(DEFINED ENV{FLEXPATH_DIR})
    if(NOT "$ENV{FLEXPATH_DIR}" STREQUAL "")
      set(FLEXPATH ON CACHE BOOL "" FORCE)
      set(FLEXPATH_DIR $ENV{FLEXPATH_DIR} CACHE FILEPATH "path to flexpath dir")
    endif()
  else()
    if(NOT "$ENV{FLEXPATH}" STREQUAL "")
      set(FLEXPATH_DIR $ENV{FLEXPATH} CACHE FILEPATH "path to flexpath dir")
      set(FLEXPATH ON CACHE BOOL "" FORCE)
    endif()
  endif()
endif()

if(DEFINED ENV{FASTBIT_DIR})
  if(NOT "$ENV{FASTBIT_DIR}" STREQUAL "")
    set(FASTBIT ON CACHE BOOL "")
    set(FASTBIT_DIR "$ENV{FASTBIT_DIR}" CACHE FILEPATH "path to fastbit dir")
  else()
    set(FASTBIT OFF CACHE BOOL "")
  endif()
else()
  if(NOT "$ENV{FASTBIT}" STREQUAL "")
    set(FASTBIT_DIR $ENV{FASTBIT} CACHE FILEPATH "path to fastbit dir")

=== src/CMakeLists.txt ===

set(EXTRA_OBJECTS "")  # added to libraries that include read+write
set(EXTRA_READ_OBJECTS "") # added to read-only libraries
# First build the mxml library in src/mxml before setting include directories for src/
# Those source files must find PROJECT_SOURCE_DIR/src/mxml/config.h first, then PROJECT_BIN/DIR/config.h
if (BUILD_MXML)
  add_subdirectory(mxml)
  set(MXML_BUILDDIR "mxml/mxml-2.9")
  set(MXML_LIB=libmxml_a)
  set(EXTRA_OBJECTS ${EXTRA_OBJECTS} $<TARGET_OBJECTS:mxml>)
endif(BUILD_MXML)

# Build the zfp library in src/zfp
if (BUILD_ZFP)
  add_subdirectory(zfp)
  set(ZFP_BUILDDIR "zfp/zfp-0.5.0")
  set(ZFP_LIB=libzfp_a)
  include_directories(${ZFP_INCLUDE_DIR})
  set(EXTRA_OBJECTS ${EXTRA_OBJECTS} $<TARGET_OBJECTS:zfp>)
  set(EXTRA_READ_OBJECTS ${EXTRA_READ_OBJECTS} $<TARGET_OBJECTS:zfp>)
endif(BUILD_ZFP)

include_directories(${PROJECT_BINARY_DIR})
include_directories(${PROJECT_SOURCE_DIR}/src ${PROJECT_SOURCE_DIR}/src/core ${PROJECT_SOURCE_DIR}/src/core/transforms)
include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
include_directories(${MXML_INCLUDE_DIR})
link_directories(${PROJECT_BINARY_DIR}/src)


if(HAVE_NSSI)
  add_executable(nssi-staging-server nssi/nssi_staging_server.cpp nssi/aggregation.cpp)
  set_target_properties(nssi-staging-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL")
  target_link_libraries(nssi-staging-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})

  add_executable(nssi-coupling-server nssi/nssi_coupling_server.cpp)
  set_target_properties(nssi-coupling-server PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_CPPFLAGS} ${MACRODEFFLAG}PTL_IFACE_CLIENT=CRAY_USER_NAL ${MACRODEFFLAG}PTL_IFACE_SERVER=CRAY_USER_NAL")
  target_link_libraries(nssi-coupling-server adios.a ${ADIOSLIB_LDADD} ${NSSI_SERVER_LIBS})
endif(HAVE_NSSI)

set(CLEANFILES "")
set(include_HEADERS "")
set(nodist_include_HEADERS "")
set(lib_LIBRARIES "")

set(libadiosread_a_CPPFLAGS "")
set(libadiosreadf_a_CPPFLAGS "")
set(libadiosread_nompi_a_CPPFLAGS "")
set(libadiosreadf_nompi_a_CPPFLAGS "")

set(libadiosread_a_CFLAGS "")
set(libadiosreadf_a_CFLAGS "")
set(libadiosread_nompi_a_CFLAGS "")
set(libadiosreadf_nompi_a_CFLAGS "")

## Transform plugin source files
set(transforms_write_method_SOURCES "")
set(transforms_read_method_SOURCES "")

include (transforms/Makefile.plugins.cmake)

##
## Core transform framework source files
##
set (transforms_common_HDRS core/adios_copyspec.h
                         core/adios_subvolume.h
                         core/adios_selection_util.h
                         core/transforms/adios_transforms_common.h
                         core/transforms/adios_transforms_hooks.h
                         core/transforms/adios_transforms_util.h
                         core/adios_subvolume.h
                         public/adios_transform_methods.h)

set (transforms_read_HDRS core/transforms/adios_transforms_read.h
                       core/transforms/adios_transforms_hooks_read.h
                       core/transforms/adios_transforms_reqgroup.h
                       core/transforms/adios_transforms_datablock.h
                       core/transforms/adios_transforms_transinfo.h
                       core/transforms/adios_patchdata.h)

set (transforms_write_HDRS  core/transforms/adios_transforms_write.h
                        core/transforms/adios_transforms_hooks_write.h
                        core/transforms/adios_transforms_specparse.h)

set (transforms_common_SOURCES  ${transforms_common_HDRS}
                            core/transforms/adios_transforms_common.c
                            core/transforms/adios_transforms_hooks.c
                            core/adios_copyspec.c
                            core/adios_subvolume.c
                            core/transforms/plugindetect/detect_plugin_infos.h
                            core/transforms/plugindetect/detect_plugin_types.h
                            core/transforms/plugindetect/plugin_info_types.h
                            core/adios_transform_methods.c)

set (transforms_read_SOURCES ${transforms_read_HDRS}
                          core/transforms/adios_transforms_read.c
                          core/transforms/adios_transforms_hooks_read.c
                          core/transforms/adios_transforms_reqgroup.c
                          core/transforms/adios_transforms_datablock.c
                          core/transforms/adios_patchdata.c
                          core/adios_selection_util.c
                          core/transforms/plugindetect/detect_plugin_read_hook_decls.h
                          core/transforms/plugindetect/detect_plugin_read_hook_reg.h
                          core/adios_read_ext.c
                          ${transforms_read_method_SOURCES})
#                          transforms/adios_transform_alacrity_read.c
#                          transforms/adios_transform_isobar_read.c
#                          transforms/adios_transform_aplod_read.c
#                          transforms/adios_transform_szip_read.c
#                          transforms/adios_transform_bzip2_read.c
#                          transforms/adios_transform_identity_read.c
#                          transforms/adios_transform_zlib_read.c
#                          transforms/adios_transform_zfp_read.c
#                          transforms/adios_transform_sz_read.c
#                          transforms/adios_transform_lz4_read.c
#                          transforms/adios_transform_blosc_read.c
#                          transforms/adios_transform_mgard_read.c

set (transforms_write_SOURCES ${transforms_write_HDRS}
                           core/transforms/adios_transforms_write.c
                           core/transforms/adios_transforms_hooks_write.c
                           core/transforms/adios_transforms_util.c
                           core/transforms/adios_transforms_specparse.c
                           ${transforms_write_method_SOURCES})
#                           transforms/adios_transform_alacrity_write.c
#                           transforms/adios_transform_aplod_write.c
#                           transforms/adios_transform_bzip2_write.c
#                           transforms/adios_transform_identity_write.c
#                           transforms/adios_transform_isobar_write.c
#                           transforms/adios_transform_szip_write.c
#                           transforms/adios_transform_zlib_write.c
#                           transforms/adios_transform_zfp_write.c
#                           transforms/adios_transform_sz_write.c
#                           transforms/adios_transform_lz4_write.c
#                           transforms/adios_transform_blosc_write.c
#                           transforms/adios_transform_mgard_write.c

#######Query source files
set(query_common_HDRS query/common_query.h
                      query/adios_query_hooks.h
                      query/query_utils.h)

set(query_common_SOURCES ${query_common_HDRS}
                         query/common_query.c
                         query/common_query_read.c
                         query/adios_query_hooks.c
                         query/query_utils.c)

# Include source files that are specific to each query plugin
set(query_method_HDRS "")
set(query_method_SOURCES "")
include(query/Makefile.plugins.cmake)

set(query_method_SOURCES ${query_method_SOURCES} ${query_method_HDRS})

set(query_SOURCES ${query_common_SOURCES} ${query_method_SOURCES})

set(query_C_SOURCES ${query_SOURCES} query/adios_query.c)
set(query_F_SOURCES ${query_SOURCES} query/adiosf_query.c)

#start adios.a and adios_nompi.a
if(BUILD_WRITE)
    set(libadios_a_SOURCES core/adios.c
                     core/common_adios.c
                     core/adios_internals.c
                     core/adios_internals_mxml.c
                     core/buffer.c
                     core/adios_bp_v1.c
                     core/adios_endianness.c
                     core/bp_utils.c
                     core/futils.c
                     core/adios_error.c
                     core/adios_read.c
                     core/adios_read_v1.c
                     core/common_read.c
                     core/adios_infocache.c
                     core/adios_read_ext.c
                     core/globals.c
                     core/adios_timing.c
                     core/adios_read_hooks.c
                     core/adios_transport_hooks.c
                     core/adios_socket.c
                     core/adios_logger.c
                     core/qhashtbl.c
                     ${transforms_common_SOURCES}
                     ${transforms_read_SOURCES}
                     ${transforms_write_SOURCES}
                     ${query_C_SOURCES}
                     core/util.c
                     core/strutil.c
                     core/a2sel.c
                     core/adios_clock.c
                     core/qhashtbl.c
                     core/adiost_callback_internal.c
                     core/adiost_default_tool.c
                     read/read_bp.c
                     read/read_bp_staged.c
                     read/read_bp_staged1.c
                     write/adios_mpi.c
                     write/adios_mpi_lustre.c
                     write/adios_mpi_amr.c
                     write/adios_posix.c
                     write/adios_var_merge.c)

    if(HAVE_BGQ)
        set(libadios_a_SOURCES ${libadios_a_SOURCES} write/adios_mpi_bgq.c)
    endif()

    set(libadios_nompi_a_SOURCES core/adios.c
                     core/common_adios.c
                     core/adios_internals.c
                     core/adios_internals_mxml.c
                     ${transforms_common_SOURCES}
                     ${transforms_read_SOURCES}
                     ${transforms_write_SOURCES}
                     ${query_C_SOURCES}
                     core/buffer.c
                     core/adios_bp_v1.c
                     core/adios_endianness.c
                     core/bp_utils.c
                     core/futils.c
                     core/adios_error.c
                     core/adios_read.c
                     core/adios_read_v1.c
                     core/common_read.c
                     core/adios_infocache.c
                     core/adios_read_ext.c
                     core/globals.c
                     core/mpidummy.c
                     core/adios_timing.c
                     core/adios_read_hooks.c
                     core/adios_transport_hooks.c
                     core/adios_socket.c
                     core/adios_logger.c
                     core/util.c
                     core/strutil.c
                     core/a2sel.c
                     core/adios_clock.c
                     core/qhashtbl.c
                     core/adiost_callback_internal.c
                     core/adiost_default_tool.c
                     read/read_bp.c
                     read/read_bp_staged.c
                     read/read_bp_staged1.c
                     write/adios_posix.c)

#start adiosf.a and adiosf_v1.a
    if(BUILD_FORTRAN)
        set(FortranLibSources core/adiosf.c
                       core/common_adios.c
                       core/adios_internals.c
                       core/adios_internals_mxml.c
                       ${transforms_common_SOURCES}
                       ${transforms_read_SOURCES}
                       ${transforms_write_SOURCES}
                       ${query_F_SOURCES}
                       core/buffer.c
                       core/adios_bp_v1.c
                       core/adios_endianness.c
                       core/futils.c
                       core/adios_error.c
                       core/bp_utils.c
                       core/common_read.c
                       core/adios_infocache.c

=== tests/CMakeLists.txt ===
set(SUITEDIR suite)
if(BUILD_WRITE)
  if(BUILD_FORTRAN)
    add_subdirectory(test_src)
    add_subdirectory(C)
    add_subdirectory(Fortran)
    add_subdirectory(genarray)
    add_subdirectory(bp_read)
    add_subdirectory(${SUITEDIR})
  else(BUILD_FORTRAN)
    add_subdirectory(test_src)
    add_subdirectory(C)
    add_subdirectory(bp_read)
    add_subdirectory(${SUITEDIR})
  endif(BUILD_FORTRAN)
endif(BUILD_WRITE)

#find_library(ADIOS_LIB adios ${PROJECT_BINARY_DIR}/src)
#if(${ADIOS_LIB}-NOTFOUND)
 # message(STATUS "cannot find adios.a in ${PROJECT_BINARY_DIR}/tests makefile")
#endif(${ADIOS_LIB}-NOTFOUND)

#if(BUILD_FORTRAN)
#  find_library(ADIOSREAD_LIB NAMES adiosreadf PATHS ${PROJECT_BINARY_DIR}/src)
#  find_library(ADIOSREAD_V1_LIB NAMES adiosreadf_v1 PATHS ${PROJECT_BINARY_DIR}/src)
#else(BUILD_FORTRAN)
#  find_library(ADIOSREAD_LIB adiosread ${PROJECT_BINARY_DIR}/src)
#  if(${ADIOSREAD_LIB}-NOTFOUND)
#    message(STATUS "cannot find adiosread.a in ${PROJECT_BINARY_DIR}/tests makefile")
#  endif(${ADIOSREAD_LIB}-NOTFOUND)
#endif(BUILD_FORTRAN)

=== examples/Fortran/CMakeLists.txt ===
add_subdirectory(scalars)
add_subdirectory(arrays)
add_subdirectory(global-array)
add_subdirectory(global-array-time)
add_subdirectory(schema)

=== src/mxml/CMakeLists.txt ===
set(MXML_SRCDIR "mxml-2.9")
include_directories(${PROJECT_SOURCE_DIR}/src/mxml)
include_directories(${PROJECT_SOURCE_DIR}/src/mxml/${MXML_SRCDIR})
include_directories(${PROJECT_BINARY_DIR}/src/mxml)
link_directories(${PROJECT_BINARY_DIR}/src/mxml)


set(CLEANFILES "")
set(include_HEADERS "")
set(nodist_include_HEADERS "")
set(lib_LIBRARIES "")

if(BUILD_MXML)
    set(libmxml_a_SOURCES 
            ${MXML_SRCDIR}/mxml-attr.c
            ${MXML_SRCDIR}/mxml-get.c 
            ${MXML_SRCDIR}/mxml-private.c
            ${MXML_SRCDIR}/mxml-string.c
            ${MXML_SRCDIR}/mxml-entity.c
            ${MXML_SRCDIR}/mxml-index.c
            ${MXML_SRCDIR}/mxml-search.c
            ${MXML_SRCDIR}/mxml-file.c 
            ${MXML_SRCDIR}/mxml-node.c
            ${MXML_SRCDIR}/mxml-set.c
       )
    set(libmxml_a_CPPFLAGS "${AM_CPPFLAGS}")
    set(libmxml_a_CFLAGS "${AM_CFLAGS}")

    add_library(mxml OBJECT ${libmxml_a_SOURCES})
    #set_target_properties(mxml PROPERTIES COMPILE_FLAGS "")

## Do not install libmxml.a, adios does not need it
#install(FILES ${PROJECT_BINARY_DIR}/mxml/libmxml.a
#        DESTINATION ${libdir})

endif(BUILD_MXML)

=== src/zfp/CMakeLists.txt ===
set(ZFP_SRCDIR "zfp-0.5.0")
include_directories(${PROJECT_SOURCE_DIR}/src/zfp/${ZFP_SRCDIR}/inc)
include_directories(${PROJECT_SOURCE_DIR}/src/zfp/${ZFP_SRCDIR})
include_directories(${PROJECT_BINARY_DIR}/src/zfp)
link_directories(${PROJECT_BINARY_DIR}/src/zfp)


set(CLEANFILES "")
set(include_HEADERS "")
set(nodist_include_HEADERS "")
set(lib_LIBRARIES "")

if(BUILD_ZFP)
    set(libzfp_a_SOURCES 
        ${ZFP_SRCDIR}/src/bitstream.c
        ${ZFP_SRCDIR}/src/decode1f.c
        ${ZFP_SRCDIR}/src/decode1d.c
        ${ZFP_SRCDIR}/src/encode1f.c
        ${ZFP_SRCDIR}/src/encode1d.c
        ${ZFP_SRCDIR}/src/decode2f.c
        ${ZFP_SRCDIR}/src/decode2d.c
        ${ZFP_SRCDIR}/src/encode2f.c
        ${ZFP_SRCDIR}/src/encode2d.c
        ${ZFP_SRCDIR}/src/decode3f.c
        ${ZFP_SRCDIR}/src/decode3d.c
        ${ZFP_SRCDIR}/src/encode3f.c
        ${ZFP_SRCDIR}/src/encode3d.c
        ${ZFP_SRCDIR}/src/zfp.c 
       )
    set(libzfp_a_CPPFLAGS "${AM_CPPFLAGS}")
    set(libzfp_a_CFLAGS "${AM_CFLAGS}")

    add_library(zfp OBJECT ${libzfp_a_SOURCES})
    #set_target_properties(zfp PROPERTIES COMPILE_FLAGS "")

## Do not install libzfp.a, adios does not need it
#install(FILES ${PROJECT_BINARY_DIR}/zfp/libzfp.a
#        DESTINATION ${libdir})

endif(BUILD_ZFP)

=== tests/Fortran/CMakeLists.txt ===
include_directories(${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/tests/Fortran)
link_directories(${PROJECT_BINARY_DIR}/tests/Fortran)

add_executable(adios_test_f adios_test_f.F90)
target_link_libraries(adios_test_f adiosf ${ADIOSLIB_LDADD})
set_target_properties(adios_test_f PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

file(COPY config_fortran.xml DESTINATION ${PROJECT_BINARY_DIR}/tests/Fortran)

=== tests/genarray/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src  ${PROJECT_BINARY_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/tests/genarray)
include_directories(${PROJECT_BINARY_DIR}/tests/genarray)
link_directories(${PROJECT_BINARY_DIR}/tests/genarray)

add_executable(genarray genarray.F90)
target_link_libraries(genarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(genarray2D genarray2D.F90)
target_link_libraries(genarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(genarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray copyarray.F90)
target_link_libraries(copyarray adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

add_executable(copyarray2D copyarray2D.F90)
target_link_libraries(copyarray2D adiosf ${ADIOSLIB_LDADD})
set_target_properties(copyarray2D PROPERTIES COMPILE_FLAGS "${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS}")

file(COPY genarray.xml genarray3d.xml job.ewok job2D.ewok DESTINATION ${PROJECT_BINARY_DIR}/tests/genarray)

=== tests/test_src/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/tests/test_src)
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/public)

include_directories(${PROJECT_BINARY_DIR}/tests/test_src)
include_directories(${PROJECT_BINARY_DIR}/src)
include_directories(${PROJECT_BINARY_DIR}/src/public)

link_directories(${PROJECT_BINARY_DIR}/tests/test_src)


set(C_PROGS_READONLY hashtest copy_subvolume text_to_pairstruct test_strutil points_1DtoND trim_spaces)

if(BUILD_WRITE)
    set(C_PROGS_WRITE transforms_specparse group_free_test query_minmax read_points_2d read_points_3d array_attribute)
endif(BUILD_WRITE)

if(BUILD_FORTRAN)
    set(F_PROGS_READONLY selection_api)
#  if(BUILD_WRITE)
#    set(F_PROGS_WRITE xxx)
#  endif(BUILD_WRITE)
endif(BUILD_FORTRAN)

foreach (PROG ${C_PROGS_READONLY} )
    add_executable(${PROG} ${PROG}.c)
    target_link_libraries(${PROG} adiosread_nompi ${ADIOSREADLIB_SEQ_LDADD})
endforeach()

foreach (PROG ${C_PROGS_WRITE} )
    add_executable(${PROG} ${PROG}.c)
    target_link_libraries(${PROG} adios_nompi ${ADIOSLIB_SEQ_LDADD})
endforeach()

foreach (PROG ${F_PROGS_READONLY} )
    add_executable(${PROG} ${PROG}.F90)
    target_link_libraries(${PROG} adiosreadf_nompi ${ADIOSREADLIB_SEQ_LDADD})
endforeach()

foreach (PROG ${F_PROGS_WRITE} )
    add_executable(${PROG} ${PROG}.F90)
    target_link_libraries(${PROG} adiosf_nompi ${ADIOSLIB_SEQ_LDADD})
endforeach()

=== utils/adios_lint/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
include_directories(${PROJECT_SOURCE_DIR}/utils/adios_lint)
include_directories(${PROJECT_BINARY_DIR} ${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
include_directories(${MXML_INCLUDE_DIR})
link_directories(${PROJECT_BINARY_DIR}/utils/adios_lint)

add_executable(adios_lint adios_lint.c)
target_link_libraries(adios_lint adios_internal_nompi ${ADIOSLIB_INT_LDADD})
set_target_properties(adios_lint PROPERTIES COMPILE_FLAGS "${ADIOSLIB_EXTRA_CPPFLAGS} ${ADIOSLIB_INT_CPPFLAGS} ${ADIOSLIB_INT_CFLAGS}")

#install(FILES config.xml DESTINATION ${PROJECT_BINARY_DIR}/utils/adios_lint)
install(PROGRAMS ${CMAKE_BINARY_DIR}/utils/adios_lint/adios_lint DESTINATION ${bindir})

=== utils/adios_list_methods/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/core)
include_directories(${PROJECT_BINARY_DIR} ${PROJECT_BINARY_DIR}/src ${PROJECT_BINARY_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/utils/adios_list_methods)
link_directories(${PROJECT_BINARY_DIR}/utils/adios_list_methods)

if(BUILD_WRITE)
  add_executable(adios_list_methods adios_list_methods.c)
  target_link_libraries(adios_list_methods adios ${ADIOSLIB_LDADD} ${MPI_C_LIBRARIES})
  set_target_properties(adios_list_methods PROPERTIES COMPILE_FLAGS "${MACRODEFFLAG}WRITE ${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${MPI_C_COMPILE_FLAGS}")

  if(MPI_LINK_FLAGS)
     set_target_properties(adios_list_methods PROPERTIES LINK_FLAGS "${MPI_C_LINK_FLAGS}")
  endif()

  install(PROGRAMS ${PROJECT_BINARY_DIR}/utils/adios_list_methods/adios_list_methods DESTINATION ${bindir})
endif(BUILD_WRITE)

add_executable(adios_list_methods_readonly adios_list_methods.c)
target_link_libraries(adios_list_methods_readonly adiosread ${ADIOSREADLIB_LDADD} ${MPI_C_LIBRARIES})
set_target_properties(adios_list_methods_readonly PROPERTIES COMPILE_FLAGS
"${ADIOSREADLIB_CPPFLAGS} ${ADIOSREADLIB_CFLAGS} ${ADIOSREADLIB_EXTRA_CPPFLAGS} ${MPI_C_COMPILE_FLAGS}")

if(MPI_LINK_FLAGS)
    set_target_properties(adios_list_methods_readonly PROPERTIES LINK_FLAGS "${MPI_C_LINK_FLAGS}")
endif()

install(PROGRAMS ${PROJECT_BINARY_DIR}/utils/adios_list_methods/adios_list_methods_readonly DESTINATION ${bindir})

=== utils/bp2bp/CMakeLists.txt ===
include_directories(${PROJECT_SOURCE_DIR}/src)
include_directories(${PROJECT_SOURCE_DIR}/src/public)
include_directories(${PROJECT_SOURCE_DIR}/utils/bp2bp)
include_directories(${PROJECT_BINARY_DIR}/src/public)
link_directories(${PROJECT_BINARY_DIR}/utils/bp2bp)

add_executable(bp2bp bp2bp.c)
target_link_libraries(bp2bp adios ${ADIOSLIB_LDADD} ${MPI_C_LIBRARIES})
set_target_properties(bp2bp PROPERTIES COMPILE_FLAGS "${MACRODEFFLAG}ADIOS_USE_READ_API_1 ${ADIOSLIB_CPPFLAGS} ${ADIOSLIB_CFLAGS} ${ADIOSLIB_EXTRA_CPPFLAGS} ${MPI_C_COMPILE_FLAGS}")

if(MPI_LINK_FLAGS)
   set_target_properties(bp2bp PROPERTIES LINK_FLAGS "${MPI_C_LINK_FLAGS}")
endif()

install(PROGRAMS ${PROJECT_BINARY_DIR}/utils/bp2bp/bp2bp DESTINATION ${bindir})

=== debian/changelog ===
adios (1.13.1-36) unstable; urgency=medium

  * Only build with openmpi on 64-bit archs

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 03 Apr 2024 09:36:55 +0100

adios (1.13.1-35) unstable; urgency=medium

  * Patch to fix FTBFS with -Werror=implicit-function-declaration.
    Closes: #1066553
  * Fix typos in VCS URLS in d/control

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 14 Mar 2024 14:18:47 +0000

adios (1.13.1-34) unstable; urgency=medium

  * B-D on dh-fortran-mod (>= 0.32)
  * Revert FMODDIR from /usr/include to libdir via dh-fortran
  * Update d/control to use fortran:Depends, fortran:Recommends

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 03 Jan 2024 08:57:09 +0000

adios (1.13.1-33) unstable; urgency=medium

  * Use cython3-legacy. Closes: #1056786

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 09 Dec 2023 18:36:44 +0000

adios (1.13.1-32) unstable; urgency=medium

  * Update paths for setuptools changes. Closes: #1054815
  * Standards-Version: 4.6.2

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 04 Nov 2023 10:38:35 +0000

adios (1.13.1-31) unstable; urgency=medium

   * ABITAG in update-alternatives not set correctly when multiple python3
     versions offered. Closes: #1025923
  * Standards-Version: 4.6.1

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 12 Dec 2022 10:56:54 +0000

adios (1.13.1-30) unstable; urgency=medium

  * Ensure libadios-*-dev provide libadios-mpi-dev
  * Fix autopkgtest to work with libadios-openmpi-dev | libadios-mpi-dev
    Closes: #998296

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 02 Nov 2021 11:49:42 +0000

adios (1.13.1-29) unstable; urgency=medium

  * Standards-Version: 4.6.0
  * Build sequential adios.pc. (LP: #1913205) 
  * Add initial autopkg tests

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 06 Sep 2021 17:28:33 +0100

adios (1.13.1-28) unstable; urgency=medium

  * postinst/prerm: Ensure generated tags correct.
    Also cope with situation where supported python changes between
    install/removal. Closes: #983888
  * Change condition to support gfortran >=9, not just <=10. Closes: #983962

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 06 Mar 2021 16:35:45 +0000

adios (1.13.1-27) unstable; urgency=medium

  * Fix build with cython3. Closes: #972420
  * Change default branch to debian/latest in d/control
  * Add 'set -e' to trap shell errors in debian/rules
  * Standards-Version: 4.5.1

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 28 Jan 2021 13:27:55 +0000

adios (1.13.1-26) unstable; urgency=medium

  * Further regeession in postinst scripts fixed. 

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 26 Sep 2020 11:57:59 +0100

adios (1.13.1-25) unstable; urgency=medium

  * Change branch paths in d/gpb.conf to DEP-14 and repos
  * Fix regression in autogenerating postinst scripts

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Sep 2020 14:40:47 +0100

adios (1.13.1-24) unstable; urgency=medium

  * d/not-installed: use wildcard instead of arch for paths
  * Fix incomplete move to subst vars

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 06 Aug 2020 08:43:40 +0100

adios (1.13.1-23) unstable; urgency=medium

  * Fix FTBFS with gfortran 10, Closes: #966966
  * Use debhelper 13
  * Use subst vars instead of autogenerating dh files
  * Add debian/not-installed

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 03 Aug 2020 18:39:34 +0100

adios (1.13.1-22) unstable; urgency=medium

  * Change update-alternatives code in postinst to dynamically detect
    python3 version. Closes: #956864

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 11 Apr 2020 19:43:38 +0100

adios (1.13.1-21) unstable; urgency=medium

  * Rebuild with netcdf-mpi-15

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 13 Mar 2020 10:16:06 +0000

adios (1.13.1-20) unstable; urgency=medium

  * Drop Fortran-Mod: clause no longer used in dh_fortran_mod
  * Use dh-sequence-* instead of dh --with *
  * Drop references to python-breaks/etc before stable
  * Standards-Version: 4.5.0
  * Patch needed (netcdf-order.patch) for netcdf-parallel transition
  * Drop obsolete breaks/depends in d/control.in
  
 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 25 Feb 2020 12:06:17 +0000

adios (1.13.1-19) unstable; urgency=medium

  * Fix: re-include regression: dropped link in d/rules. Closes: #933796 
  * Update pre/post scripts; drop obsolete refs to py36

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 09 Aug 2019 11:50:53 +0100

adios (1.13.1-18) unstable; urgency=medium

  * Rebuild against latest mpi4py
  * Drop references to cython  ; ensure python3 not python is used.
  * B-D on python3-numpy

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 01 Aug 2019 09:50:21 +0100

adios (1.13.1-17) unstable; urgency=medium

  * B-D on gfortran | fortran-compiler
  * Drop python2 support
  * Now use debhelper-compat = 12
  * Standards-Version: 4.4.0

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 19 Jul 2019 09:23:03 +0100

adios (1.13.1-16) unstable; urgency=medium

  * Check full path of link for /etc/alternatives in python3-adios.postinst
    and delete obsolete link if present. Closes: #920700

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 29 Jan 2019 09:23:59 +0000

adios (1.13.1-15) unstable; urgency=medium

  * Patch from Steve Langasek for unaligned accesses that cause armhf
    binaries to crash on arm64. Closes: #919763

 -- Alastair McKinstry <mckinstry@debian.org>  Mon, 28 Jan 2019 09:39:26 +0000

adios (1.13.1-14) unstable; urgency=medium

  * Don't run tests on armhf. When built on arm64, there are known failures
    due to unaligned accesses. Closes: #919763

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 25 Jan 2019 06:23:43 +0000

adios (1.13.1-13) unstable; urgency=medium

  * Fix for python3-adios postinst deleting old py36 file. 

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 06 Jan 2019 07:28:16 +0000

adios (1.13.1-12) unstable; urgency=medium



=== debian/control ===
Source: adios
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-sequence-python3,
  dh-fortran-mod (>= 0.32),
  mpi-default-dev,
  libnetcdf-dev, 
  libnetcdf-mpi-dev (>= 4.6.1-3),
  libmxml-dev, 
  libopenmpi-dev [alpha amd64 arm64 ia64 kfreebsd-amd64  mips64el  ppc64 ppc64el riscv64 s390x sparc64],
  openmpi-bin [alpha amd64 arm64 ia64 kfreebsd-amd64  mips64el  ppc64 ppc64el riscv64 s390x sparc64],
  libmpich-dev, mpich,
  liblz4-dev,
  libblosc-dev,
  pkg-config,
  cmake, 
  libbz2-dev,  
  zlib1g-dev, 
  libibverbs-dev [ !hurd-i386 !kfreebsd-i386 !kfreebsd-amd64],
  python3-all-dev, 
  python3-mpi4py, 
  python3-numpy,
  cython3-legacy, 
  libglib2.0-dev, 
  libhdf5-dev, 
  libhdf5-mpich-dev,
  libhdf5-openmpi-dev,
  libaec-dev
Build-Conflicts: libadios-dev, 
 libadios-bin
Standards-Version: 4.6.2
Homepage: https://www.olcf.ornl.gov/center-projects/adios/
Vcs-Browser: https://salsa.debian.org/science-team/adios.git
Vcs-Git: https://salsa.debian.org/science-team/adios.git -b debian/latest

Package: libadios-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:  ${misc:Depends}, 
   ${shlibs:Depends}, 
   ${python3:Depends}, 
   ${fortran:Depends},
   pkg-config
Recommends: libadios-bin,
   ${fortran:Depends}
Description: ADIOS Adaptable IO system for simulations
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.

Package: libadios-openmpi-dev
Section: libdevel
Architecture: alpha amd64 arm64 ia64 kfreebsd-amd64 mips64el ppc64 ppc64el riscv64 s390x  sparc64
Multi-Arch: same
Depends:  ${misc:Depends}, libadios-dev
Recommends: libadios-bin, libadios-examples
Provides: libadios-mpi-dev
Description: ADIOS Adaptable IO system (OpenMPI development files)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.

Package: libadios-mpich-dev
Section: libdevel
Architecture: alpha amd64 arm64 armel armhf hppa hurd-i386 i386 ia64 kfreebsd-amd64 kfreebsd-i386 m68k mips mips64el mipsel powerpc powerpcspe ppc64 ppc64el riscv64 s390x sh4 sparc64 x32
Multi-Arch: same
Depends:  ${misc:Depends}, libadios-dev
Recommends: libadios-bin, libadios-examples
Provides: libadios-mpi-dev
Description: ADIOS Adaptable IO system (MPICH development files)
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.

Package: libadios-examples
Architecture: all
Depends: ${misc:Depends}
Multi-Arch: foreign
Recommends: libadios-dev
Description: Examples for the ADIOS Adaptable IO system
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.


Package: libadios-bin
Depends:  ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}
Architecture: any
Multi-Arch: foreign
Recommends: libadios-dev
Description: ADIOS Adaptable IO system for simulations - binaries
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .
 This package provides tools for use with ADIOS.

Package: python3-adios
Depends: ${python3:Depends}, ${misc:Depends}, ${shlibs:Depends}
Section: python
Architecture: any
Provides: ${python:Provides}
Description: Python3 interface to the ADIOS IO system
 This is a Python3 interface to ADIOS.
 .
 The Adaptable IO System (ADIOS) provides a simple, flexible way for scientists
 to describe the data in their code that may need to be written, read,
 or processed outside of the running simulation. By providing an external
 to the code XML file describing the various elements, their types, and
 how you wish to process them this run, the routines in the host code
 (either Fortran or C) can transparently change how they process the data.
 .

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
include /usr/share/debhelper/dh-fortran/fortran-support.mk
include /usr/share/mpi-default-dev/debian_defaults

ARCH:=$(shell dpkg --print-architecture)

AUTOGENERATED:=   adios_config control libadios-bin.postinst  \
                 libadios-mpich-dev.postinst libadios-openmpi-dev.postinst \
                 libadios-mpich-dev.prerm libadios-openmpi-dev.prerm \
                 python3-adios.postinst python3-adios.prerm


MPI_LIBS_OPENMPI:= $(pkg-config ompi-fort --libs)
MPI_LIBS_MPICH:= $(pkg-config mpich-fort --libs)


WITH_IBVERBS:= --with-infiniband=/usr
ifeq ($(ARCH),hurd-i386)
  WITH_IBVERBS:=
endif
ifeq ($(ARCH),kfreebsd-amd64)
  WITH_IBVERBS:=
endif
ifeq ($(ARCH),kfreebsd-i386)
  WITH_IBVERBS:=
endif

# TODO: also mpich2 for x32 ...
# DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

# See  #966966
GF10_FLAGS:=$(if $(filter $(shell readlink /usr/bin/gfortran), gfortran-9), \
                 , -fallow-invalid-boz -fallow-argument-mismatch )
export FFLAGS=$(shell dpkg-buildflags --get FFLAGS) $(GF10_FLAGS)
export FCFLAGS=$(shell dpkg-buildflags --get FCFLAGS) $(GF10_FLAGS)

DESTDIR:=$(shell pwd)/debian/tmp
DEB_HOST_MULTIARCH?=$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
BINDIR:=$(DESTDIR)/usr/bin
PY3VERS:=$(shell py3versions -s)
PY3VERD:=$(shell py3versions -d)
ABITAG:=$(shell ${PY3VERD} -c "import sysconfig; print(sysconfig.get_config_var('SOABI'))" )
CFLAGS:=$(shell  dpkg-buildflags --get CFLAGS )

MPIDESTDIR:=$(DESTDIR)/$(ARCH_DEFAULT_MPI_IMPL)
BUILD_MPI:=build-$(ARCH_DEFAULT_MPI_IMPL)

export VERSION=${DEB_VERSION_UPSTREAM}
export DEFAULT_MPI=${ARCH_DEFAULT_MPI_IMPL}

TOP:=$(shell pwd)
# to find adios_config
export PATH:=$(TOP):$(PATH)

# magic debhelper rule
%:
	dh $@ 

override_dh_auto_clean:
	dh_clean	
	find . -name '*.pyc'  -o -name '*.o'  -o  -name '*.a' -o  -name '*.mod' -delete
	rm -fr  build-* 
	# Remove dodgy symlinks
	find . -type l -delete
	rm -f ./examples/staging/stage_write/writer_adios config.log 
	rm -f libtool config.h  config.status adios_config.flags  adios_config
	rm -f adios-mpi.pc adios.pc stamp-h1
	find . -name .gitignore -delete

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed 	-e 's%@VERSION@%${DEB_VERSION_UPSTREAM}%g' < debian/$$f.in     \
			-e 's%@OMPIARCHS@%${OPENMPI_AVAILABLE_ARCHITECTURES}%g' \
	    		-e 's%@MPICHARCHS@%${MPICH_AVAILABLE_ARCHITECTURES}%g' \
	    		-e 's%@DEB_HOST_MULTIARCH@%${DEB_HOST_MULTIARCH}%g' \
			-e 's%@DEFAULT_MPI@%${ARCH_DEFAULT_MPI_IMPL}%g' \
			-e 's%@ABITAG@%${ABITAG}%g' \
		      < debian/$$f.in > debian/$$f ; \
                done
ifneq (,$(findstring $(ARCH),$(MPICH_AVAILABLE_ARCHITECTURES)))
	CONFIG_SHELL=/bin/bash dh_auto_configure --builddirectory=build-mpich  -- \
		$(WITH_LUSTRE) $(WITH_IBVERBS) --enable-shared \
		--with-nc4par=yes \
		--with-nc4par-incdir=$(LIBDIR)/netcdf/mpi/include \
		--with-nc4par-libdir=$(LIBDIR)/netcdf/mpi \
		--with-hdf5-incdir=/usr/include/hdf5/serial \
		--with-hdf5-libdir=$(LIBDIR)/hdf5/serial \
		--with-phdf5-incdir=/usr/include/hdf5/mpich \
		--with-phdf5-libdir=$(LIBDIR)/hdf5/mpich \
		--with-lz4=/usr --with-szip=/usr --with-blosc=/usr \
		--with-bzip2=/usr  --with-zlib=/usr --with-glib=/usr \
		--prefix=/usr MPICC=mpicc.mpich MPIFC=mpif90.mpich CFLAGS='$(CFLAGS) -I$(LIBDIR)/glib-2.0/include' \
		LIBS=' $(MPI_LIBS_MPICH) -lpthread'  SHELL=/bin/bash CONFIG_SHELL=/bin/bash
	cp -a wrappers/numpy build-mpich
endif
ifneq (,$(findstring $(ARCH),$(OPENMPI_AVAILABLE_ARCHITECTURES)))
	CONFIG_SHELL=/bin/bash dh_auto_configure --builddirectory=build-openmpi  -- \
		$(WITH_LUSTRE) $(WITH_IBVERBS) --enable-shared \
		--with-nc4par=yes \
		--with-nc4par-incdir=$(LIBDIR)/netcdf/mpi/include \
		--with-nc4par-libdir=$(LIBDIR)/netcdf/mpi \
		--with-hdf5-incdir=/usr/include/hdf5/serial \
		--with-hdf5-libdir=$(LIBDIR)/hdf5/serial \
		--with-phdf5-incdir=/usr/include/hdf5/openmpi \
		--with-phdf5-libdir=$(LIBDIR)/hdf5/openmpi \
		--with-lz4=/usr --with-szip=/usr --with-blosc=/usr \
		--with-bzip2=/usr  --with-zlib=/usr --with-glib=/usr \
		--prefix=/usr MPICC=mpicc.openmpi MPIFC=mpif90.openmpi CFLAGS='$(CFLAGS) -I$(LIBDIR)/glib-2.0/include' \
		LIBS=' $(MPI_LIBS) -lpthread'  SHELL=/bin/bash CONFIG_SHELL=/bin/bash
	cp -a wrappers/numpy build-openmpi
endif

override_dh_auto_build:
	# First do a build shared, with -fPIC, for the python lib.
ifneq (,$(findstring $(ARCH),$(MPICH_AVAILABLE_ARCHITECTURES)))
	dh_auto_build --builddirectory=build-mpich -- CFLAGS='$(CFLAGS) -fPIC' VERBOSE=1
endif
ifneq (,$(findstring $(ARCH),$(OPENMPI_AVAILABLE_ARCHITECTURES)))
	dh_auto_build --builddirectory=build-openmpi -- CFLAGS='$(CFLAGS) -fPIC' VERBOSE=1
endif
	# Need to hack the libs into the right place, to match adios_configs view
	# as this is then used by setup.py
	install -D -t debian/tmp/usr/lib $(BUILD_MPI)/src/*.a 
	install -m 755 -t $(TOP) $(BUILD_MPI)/adios_config $(BUILD_MPI)/adios_config.flags
	# MPICH 
ifneq (,$(findstring $(ARCH),$(MPICH_AVAILABLE_ARCHITECTURES)))
	install -D -t debian/tmp/usr/lib build-mpich/src/*.a
	for p in $(PY3VERS) ; do \
		( set -e ; cd build-mpich/numpy && \
		$(MAKE) python3  CYTHON3=y MPI=y && \
		$$p ./setup_mpi.py build_ext --mpicc=mpicc.mpich --mpicxx=mpicxx.mpich ) ;  \
		done
endif
	# OpenMPI
ifneq (,$(findstring $(ARCH),$(OPENMPI_AVAILABLE_ARCHITECTURES)))
	install -D -t debian/tmp/usr/lib build-openmpi/src/*.a
	for p in $(PY3VERS) ; do \
		( set -e ;  cd build-openmpi/numpy && \
		$(MAKE) python3  CYTHON3=y MPI=y && \
		$$p ./setup_mpi.py build_ext --mpicc=mpicc.openmpi --mpicxx=mpicxx.openmpi ) ;  \
		done
endif
	# Now the static build
	dh_auto_build

override_dh_auto_install:
	mkdir -p $(BINDIR) debian/tmp/usr/lib/python3/dist-packages $(DESTDIR)/usr/etc
ifneq (,$(findstring $(ARCH),$(MPICH_AVAILABLE_ARCHITECTURES)))
	dh_auto_install --builddirectory=build-mpich --destdir=$(TOP)/debian/tmp/mpich -- VERBOSE=1
	install -D -m 644  build-mpich/adios-mpi.pc $(TOP)/debian/tmp/$(LIBDIR)/pkgconfig/adios-mpich.pc
	for p in  $(PY3VERS) ; do \
		( set -e ; cd build-mpich/numpy && \
		$$p ./setup_mpi.py install --prefix=$(DESTDIR)/mpich  ) ;  \
		mv debian/tmp/mpich/local/lib/$$p/dist-packages/adios_mpi \
		   debian/tmp/mpich/local/lib/$$p/dist-packages/adios_mpich ; \
		done
	for p in $(PY3VERS) ; do \
		cp -a debian/tmp/mpich/local/lib/$$p/dist-packages/* debian/tmp/usr/lib/python3/dist-packages ; \
		done
	for p in bp2bp bp2ncd bpappend bpdump bpgettime bpls bpsplit skeldump adios_lint ; do \
		cp debian/tmp/mpich/usr/bin/$$p $(BINDIR)/$$p.mpich ; \
		done
	cp -a debian/tmp/mpich/usr/etc/skel $(DESTDIR)/usr/etc/skel.mpich
endif
ifneq (,$(findstring $(ARCH),$(OPENMPI_AVAILABLE_ARCHITECTURES)))
	dh_auto_install --builddirectory=build-openmpi --destdir=$(TOP)/debian/tmp/openmpi -- VERBOSE=1
	install -D -m 644  build-openmpi/adios-mpi.pc debian/tmp/$(LIBDIR)/pkgconfig/adios-openmpi.pc
	# Sort python stuff
	for p in $(PY3VERS) ; do \
		( set -e ; cd build-openmpi/numpy && \
		$$p ./setup_mpi.py install --prefix=$(DESTDIR)/openmpi  ) ;  \
		mv debian/tmp/openmpi/local/lib/$$p/dist-packages/adios_mpi \
	           debian/tmp/openmpi/local/lib/$$p/dist-packages/adios_openmpi ; \
		done
	for p in $(PY3VERS) ; do \
		cp -a debian/tmp/openmpi/local/lib/$$p/dist-packages/* debian/tmp/usr/lib/python3/dist-packages ; \
		done
	for p in bp2bp bp2ncd bpappend bpdump bpgettime bpls bpsplit skeldump adios_lint skel ; do \
		cp debian/tmp/openmpi/usr/bin/$$p $(BINDIR)/$$p.openmpi ; \
		done
	cp -a debian/tmp/openmpi/usr/etc/skel $(DESTDIR)/usr/etc/skel.openmpi
endif
	# serial
	install -D -t debian/tmp/usr/lib $(BUILD_MPI)/src/*.a
	install -D -m 644  $(BUILD_MPI)/adios.pc debian/tmp/$(LIBDIR)/pkgconfig/adios.pc
	(find debian/tmp/usr/lib/python3/ -name '__pycache__' -exec rm -rf {} \; ) || true
	# renamed as per Adios CCS issue #118716, Debbug #639257
	mkdir -p $(BINDIR)

=== debian/tests/control ===
Test-Command: set -e
  ; adios_config 2> /dev/null
Depends: libadios-bin

Test-Command: set -e
  ; pkg-config adios --libs 2> /dev/null
Depends: pkg-config, libadios-dev

Test-Command: set -e
  ; pkg-config adios-mpi --libs 2> /dev/null
Depends: pkg-config, libadios-openmpi-dev | libadios-mpi-dev

=== debian/watch ===
# https://users.nccs.gov/~pnorbert/adios-1.13.1.tar.gz
version=3
http://users.nccs.gov/~pnorbert/ .*/adios-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
